	;; 
	;; Make a straight path, then return to rtrn
	;; 

Func EAGERMOVE (cond, rtrn)
Move done do
do: If cond Goto rtrn  
Move done do
done:
End

Func MAKETRAIL (cond, mrk1, mrk2, rtrn)
        Turn Right .
repeat:
	Call EAGERMOVE (cond, rtrn)
	Mark mrk1 .
        Turn Left .
        Turn Left .
	Call EAGERMOVE (cond, rtrn)
	Mark mrk2 .
        Turn Right .
        Turn Right repeat

End


Func TESTONCE (rtrn)
	If AllOf(Not Sensing LeftAhead Friend
		 Not Sensing Ahead Friend
		 Not Sensing RightAhead Friend) Then
		 Call MAKETRAIL (Sensing Ahead Rock, 1, 0, rtrn)
	Else
	End
End
			
		
start:
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .

If Flip 2 Then
edge1:
        SetName "!" "?"
        If Sensing RightAhead Home Then
          Move edge1 edge1turn
        Else
edge1turn:
          Turn Right edge1
        End
 
Else
	Drop forage
End
	;; 
	;; Go get some food -- from bouncer.asm
	;; Returns to rtrn when it has food
	;; 
Func FINDFOOD (rtrn)
try-to-find-food:
	Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
	PickUp got-food .
   If Sensing RightAhead Food Then
     Turn Right no-food-here
   Else End
   If Sensing LeftAhead Food Then
     Turn Left no-food-here
   Else End
   If Sensing Ahead Marker 2 Then
     Turn Left ok-to-try-to-get-food
   Else End
   If Sensing Ahead Marker 3 Then
     Turn Right ok-to-try-to-get-food
   Else End
no-food-here:
	Move try-to-find-food man-i-hit-something
man-i-hit-something:
	;;  try turning in a random direction.
	Flip 2 rotate-cw rotate-ccw
rotate-cw:
	Turn Right Next
	;;  maybe keep turning!
	Flip 2 rotate-cw try-to-find-food
rotate-ccw:
	Turn Left Next
	Flip 2 rotate-ccw try-to-find-food
got-food:
	Turn Right .
	Turn Right .
	Turn Right rtrn
End


	;;
	;; If you have food walk around until you find a spoke -- then run-home
	;; 
Func FINDHOME (rtrn)

If Flip 30 Then
    Call MAKETRAIL (AnyOf(Sensing Ahead Rock
                          Sensing Ahead Home
                          Sensing Ahead Marker 0
                          Sensing Ahead Marker 1
                          Sensing Ahead Marker 2
                          Sensing Ahead Marker 3), 2, 3, have-food)
Else End

have-food:
	Sense drop-my-food no-base-here Here Home

drop-my-food:
	Drop .
	Turn Right .
	Turn Right .
	Turn Right rtrn		

no-base-here:
   If Sensing Ahead Marker 1 Then
     Turn Left no-base-here
   Else End
   If Sensing Ahead Marker 0 Then
     Turn Right no-base-here
   Else End
   SetName "?" "?"
   Call EAGERMOVE (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
   SetName "@" "@"   
   Sense have-food have-food Ahead Rock


fhit-something:
	If Flip 2 Then 
         Turn Right have-food
        Else
         Turn Left have-food 
        End



End ; FINDHOME

	
forage:
        SetName "*" "*"
	Call FINDFOOD (go-home)

go-home:
        SetName "@" "@"
	Call FINDHOME (forage)


