
;;; dedicate a few ants to filling in the borders of the map.
;;; this shrinks the search space, at the expense of a sense
;;; test.

; Func TURNAROUND()
;     Turn Left .
;     Turn Left .
;     Turn Left .
; End

decide-role:
    If AllOf (Not (Sensing Ahead Home)
	      Not (Sensing LeftAhead Home)
	      Not (Sensing RightAhead Home)) Goto floodfill
;;; turn around.
    Turn Left .
    Turn Left .
    Turn Left .
    If AllOf (Not (Sensing Ahead Home)
	      Not (Sensing LeftAhead Home)
	      Not (Sensing RightAhead Home)) Goto floodfill
;;; otherwise, just a regular dude.

;;; XXX should probably do something!
regular-dude:
    Drop regular-dude

;;;  XXX this can 'pinch off' areas of
;;;  the map and make them inaccessible
    
;;;  the idea of floodfill is to hug,
;;   always going counter-clockwise,
;;;  permanent objects (mark 5 and rocks)
;;;  laying down mark 5 as we go. If we
;;;  ever run across something useful, we
;;;  stop marking and become a regular dude.

;;;  (one idea would be to reserve another mark
;;;  for 'good')
floodfill:
    SetName "F" "W"
    Move try-to-find-obstacle try-to-find-obstacle
    
try-to-find-obstacle:
    If AllOf (AnyOf ((Sensing Ahead Rock) (Sensing Ahead Marker 5))
              Not (AnyOf (Sensing Here Food
			  Sensing Here Home
			  Sensing Here FoeHome))) Then
    ;;;  found an obstacle, and we're on clear ground.
	SetName "E" "E"
       	Mark 5 .
	Turn Left face-ccw-edge
    Else
    ;;;  should do some sort of evasive move. we can be on the
    ;;;  edge where there is food (dropped), or walking against
    ;;   another stubborn ant, etc.
	Move try-to-find-obstacle try-to-find-obstacle
    End

;;;  turn so that we have obstacle rightahead and
;;;  clear ahead. we know that we just made a mark,
;;;  but would have been on clear ground, and that
;;;  there is an obstacle rightahead.
face-ccw-edge:
;;;  if we find something cool on the edge, then exit.
    If AnyOf (Sensing Ahead Food
	      Sensing Ahead Home
	      Sensing Ahead FoeHome) Goto found-cool
    
    If Not (AnyOf (Sensing Ahead Rock
		   Sensing Ahead Marker 5)) Then
	;;;  this should also be a stubborn move
    	Move new-edge-cell face-ccw-edge
    Else
    ;;;  might want to eventually do some evasion here
	Turn Left face-ccw-edge
    End

;;;  could optimize this, since we know that after two
;;;  right turns we'll be facing an obstacle.
new-edge-cell:
    Turn Right .
    Turn Right try-to-find-obstacle
    
;;;  should probably become forager.
found-cool:
    SetName "C" "K"
looping:
    Drop looping