
;;;  main screen turn on.


Define CATS 4
        

Func EAGERMOVE (cond, rtrn)
do: If cond Goto rtrn 
Move done do
done:
End

Func MAKETRAIL (cond, mrk1, mrk2, rtrn)
        Turn Right .
repeat:
	Call EAGERMOVE (cond, rtrn)
	Mark mrk1 .
        Turn Left .
        Turn Left .
	Call EAGERMOVE (cond, rtrn)
	Mark mrk2 .
        Turn Right .
        Turn Right repeat

End


Func TESTONCE (rtrn)
	If AllOf(Not Sensing LeftAhead Friend
		 Not Sensing Ahead Friend
		 Not Sensing RightAhead Friend) Then
		 Call MAKETRAIL (Sensing Ahead Rock, 1, 0, rtrn)
	Else
	End
End
			
		
start:
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
;;;  everyone else becomes an attacker

become-attacker:    
    Sense found-base no-enemy-base Ahead FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
try-to-face-cw:	
;;;  now try to face cw.
    If AllOf(Not (Sensing Ahead FoeHome)
	     Sensing RightAhead FoeHome) Goto at-base-facing-cw
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw

;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-cw:  
    Mark CATS .
    Move found-base at-base-facing-cw
    
;;;  keep looking ... 
no-enemy-base:
    Move become-attacker hit-while-attacking

hit-while-attacking:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    If Sensing Here Marker CATS Goto turn-away
    Sense blocked-at-base Next Ahead (Marker CATS)
;;;  otherwise, just turn away:	
    
turn-away:
    Flip 2 arot-cw arot-ccw
arot-cw:
    Turn Right Next
    Flip 3 arot-cw no-enemy-base
arot-ccw:
    Turn Left Next
    Flip 3 arot-ccw no-enemy-base

;;; I know I'm facing their base edge, on non-base
blocked-at-base:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base
    Move become-attacker blocked-at-base



    	;; 
	;; Go get some food -- from bouncer.asm
	;; Returns to rtrn when it has food
	;; 
Func FINDFOOD (rtrn)
try-to-find-food:
	Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
	PickUp got-food .
   If Sensing RightAhead Food Then
     Turn Right no-food-here
   Else End
   If Sensing LeftAhead Food Then
     Turn Left no-food-here
   Else End
   If Sensing Ahead Marker 2 Then
     Turn Left ok-to-try-to-get-food
   Else End
   If Sensing Ahead Marker 3 Then
     Turn Right ok-to-try-to-get-food
   Else End
no-food-here:
	Move try-to-find-food man-i-hit-something
man-i-hit-something:
	;;  try turning in a random direction.
	Flip 2 rotate-cw rotate-ccw
rotate-cw:
	Turn Right Next
	;;  maybe keep turning!
	Flip 2 rotate-cw try-to-find-food
rotate-ccw:
	Turn Left Next
	Flip 2 rotate-ccw try-to-find-food
got-food:
	Turn Right .
	Turn Right .
	Turn Right rtrn
End


	;;
	;; If you have food walk around until you find a spoke -- then run-home
	;; 
Func FINDHOME (rtrn)

If Flip 30 Then
    Call MAKETRAIL (AnyOf(Sensing Ahead Rock
                          Sensing Ahead Home
                          Sensing Ahead Marker 0
                          Sensing Ahead Marker 1
                          Sensing Ahead Marker 2
                          Sensing Ahead Marker 3), 2, 3, have-food)
Else End

have-food:
	Sense drop-my-food no-base-here Here Home

drop-my-food:
	Drop .
	Turn Right .
	Turn Right .
	Turn Right rtrn		

no-base-here:
   If Sensing Ahead Marker 1 Then
     Turn Left no-base-here
   Else End
   If Sensing Ahead Marker 0 Then
     Turn Right no-base-here
   Else End
   Move have-food fhit-something


fhit-something:
	Flip 2 frotate-cw frotate-ccw

frotate-cw:
	Turn Right Next
	Flip 2 frotate-cw have-food

frotate-ccw:
	Turn Left Next
	Flip 2 frotate-ccw have-food

run-home:
	Move . fhit-something
	Sense drop-my-food run-home Here Home
End


become-forager: 	
forage:
        SetName "X" "O"
	Call FINDFOOD (go-home)

go-home:
        SetName "&" "&"
	Call FINDHOME (forage)



