
Define NEARFOOD 5

Define CHANCE_OF_TRACE 10
Define LENGTH_OF_TRACE 15
Define CHANCE_OF_ESCAPE 3

;;;
;;; Become a Bouncer ant, looking for food
;;;
Func BOUNCER ()
goleft:
    Turn Left Next
    Turn Left try-to-find-food 
goright:
    Turn Right Next
    Turn Right try-to-find-food

try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
    PickUp got-food no-food-here
no-food-here:
;    Move Next man-i-hit-something
;    PickUp got-food Next
    If Sensing Here Marker NEARFOOD Goto follow-mark
    Move try-to-find-food man-i-hit-something

follow-mark:
    If Not AnyOf(Sensing Ahead Food
                 Sensing Ahead Marker NEARFOOD
                 Not Flip CHANCE_OF_ESCAPE) Then
	If Flip 3 Then 
            Turn Right follow-mark
        Else 
            Turn Left follow-mark
        End
    Else End
    Move ok-to-try-to-get-food no-food-here


man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right try-to-find-food

rotate-ccw:
    Turn Left try-to-find-food

got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    If Flip CHANCE_OF_TRACE Goto trace-food
    ;;  try to find base
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Drop try-to-find-food
    
no-base-here:
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right have-food

frotate-ccw:
    Turn Left have-food


Func PATIENT_MOVE(cond, otherwise)
repeat:
    Move done .
    While cond
	Move done repeat
    End
    If True Goto otherwise
done:
End

trace-food:
    While AnyOf(Sensing Here Food 
		Sensing Here Marker NEARFOOD)
	Call PATIENT_MOVE (Not Flip 10, have-food)
    End
    While Not AnyOf(Sensing AheadRight Food
		    Sensing AheadRight Marker NEARFOOD)
	Turn Right .
    End
    Repeat LENGTH_OF_TRACE
	Mark NEARFOOD .
	Call PATIENT_MOVE (Not Flip 10, have-food)
	While Not AnyOf(Sensing AheadRight Food
		        Sensing AheadRight Marker NEARFOOD)
		Turn Right .
	End	
    End
    If True Goto have-food

End


start:
	Call BOUNCER ()
