	;; 
	;; Make a straight path, then return to rtrn
	;; 

Func EAGERMOVE (cond, rtrn)
Move done do
do: If cond Goto rtrn  
Move done do
done:
End

Func EAGERMOVE-SLOPPY (cond, rtrn)
maymove:    
Move done .
Move done .
turny:	
If (Flip 3) Then
    Turn Left .
    Move . oopsl
    Turn Right .
Else End

If (Flip 3) Then
    Turn Right .
    Move . oopsr
    Turn Left .
Else End
    
    
do: If cond Goto rtrn  
Move done turny
oopsl:
    Turn Right maymove
oopsr:
    Turn Left maymove
done:
End

    
Func MAKETRAIL (cond, mrk1, mrk2, rtrn)
        Turn Right .
repeat:
	Call EAGERMOVE (cond, rtrn)
        If AnyOf (Sensing LeftAhead Marker 0
                  Sensing LeftAhead Marker 1
                  Sensing LeftAhead Rock) Goto rtrn
	Mark mrk1 .
        Turn Left .
        Turn Left .
	Call EAGERMOVE (cond, rtrn)
        If AnyOf (Sensing RightAhead Marker 0
                  Sensing RightAhead Marker 1
                  Sensing RightAhead Rock) Goto rtrn
	Mark mrk2 .
        Turn Right .
        Turn Right repeat

End

    

Func TESTONCE (rtrn)
	If AllOf(Not Sensing LeftAhead Friend
		 Not Sensing Ahead Friend
		 Not Sensing RightAhead Friend) Then
		 Call MAKETRAIL (Sensing Ahead Rock, 1, 0, spokeagain)
                 spokeagain:
                 Turn Right .
                 Turn Right .
                 Turn Right .
                 Call MAKETRAIL (Sensing Ahead Rock, 4, 5, rtrn) 
	Else
	End
End
			
		
start:
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .

If Flip 2 Then
edge1:
        SetName "!" "?"
        If Sensing RightAhead Home Then
          Move edge1 edge1turn
        Else
edge1turn:
          Turn Right edge1
        End
 
Else
	Drop forage
End
	;; 
	;; Go get some food -- from bouncer.asm
	;; Returns to rtrn when it has food
	;; 
Func FINDFOOD (rtrn)
try-to-find-food:
	Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
	PickUp got-food .
   If Sensing RightAhead Food Then
     Turn Right no-food-here
   Else End
   If Sensing LeftAhead Food Then
     Turn Left no-food-here
   Else End
   If Sensing Ahead Marker 2 Then
     Call EAGERMOVE(Flip 100, try-to-find-food )
     Turn Left follow-path
   Else End
;   If Sensing Ahead Marker 3 Then
;     Turn Right ok-to-try-to-get-food
;   Else End
no-food-here:
	Move try-to-find-food man-i-hit-something
man-i-hit-something:
	;;  try turning in a random direction.
	Flip 2 rotate-cw rotate-ccw
rotate-cw:
	Turn Right Next
	;;  maybe keep turning!
	Flip 2 rotate-cw try-to-find-food
rotate-ccw:
	Turn Left Next
	Flip 2 rotate-ccw try-to-find-food
got-food:
	Turn Right .
	Turn Right .
	Turn Right . 
        Call EAGERMOVE(Flip 100, rtrn )
        Call EAGERMOVE(Flip 100, rtrn )
        If True Goto rtrn
follow-path:
     SetName "$" "$"
     PickUp got-food .
     If Not Sensing Here Marker 2 Goto try-to-find-food
     If Sensing Here Marker 3 Then
      If Sensing Ahead Marker 2 Then 
        Unmark 3 .
       Else
   	Turn Right .
	Turn Right .
	Turn Right .
       End
     Else 
      If Not Sensing Ahead Marker 2 Then 
       Unmark 2 .
      Else End
     End
     SetName "=" "="  
     Call EAGERMOVE(Flip 100, turn-to-find-food)
     If True Goto follow-path
turn-to-find-food:
     Unmark 2 .
     Turn Right try-to-find-food
End


	;;
	;; If you have food walk around until you find a spoke -- then run-home
	;; 
Func FINDHOME (rtrn)

;If Flip 30 Then
;    Call MAKETRAIL (AnyOf(Sensing Ahead Rock
;                          Sensing Ahead Home
;                          Sensing Ahead Marker 0
;                          Sensing Ahead Marker 1
;                          Sensing Ahead Marker 2
;                          Sensing Ahead Marker 3), 2, 3, have-food)
;Else End

Variable excited Of (first yes no) In

 Switch excited Of Case first
   If Flip 20 Then Assign excited yes Else Assign excited no End
 End

have-food:
	Sense drop-my-food no-base-here Here Home

drop-my-food:
	Drop .
	Turn Right .
	Turn Right .
	Turn Right rtrn		

no-base-here:
nbh:
   Switch excited Of Case yes Mark 2 . End
   If Sensing Ahead Marker 1 Then
     Assign excited no
     Turn Left nbh
   Else End
   If Sensing Ahead Marker 0 Then
     Switch excited Of Case yes Mark 3 . End
     Assign excited no
     Turn Right nbh
   Else End
   If Sensing Ahead Marker 5 Then
     Switch excited Of Case yes Mark 3 . End
     Assign excited no
     Turn Right .
     Turn Right .
     Turn Right nbh
   Else End
   If Sensing Ahead Marker 4 Then
     Switch excited Of Case yes Mark 3 . End
     Assign excited no
    Call EAGERMOVE-SLOPPY (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
    Call EAGERMOVE-SLOPPY (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
    If True Goto nbh
   Else End
   SetName "?" "?"
   Switch excited Of 
    Case yes Call EAGERMOVE (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
    Case no  Call EAGERMOVE-SLOPPY (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
   End
   SetName "@" "@"   
   Sense have-food have-food Ahead Rock


fhit-something:
     Switch excited Of Case yes Mark 3 . End
     Assign excited no
	If Flip 2 Then 
         Turn Right have-food
        Else
         Turn Left have-food 
        End

End ; Var

End ; FINDHOME

	
forage:
        SetName "*" "*"
	Call FINDFOOD (go-home)

go-home:
        SetName "@" "@"
	Call FINDHOME (forage)


