	;; 
	;; Make a straight path, then return to rtrn
	;; 
Func MAKETRAIL (mrk, rtrn)
repeat:
	Mark mrk .
	Move repeat rtrn
End

Func TESTONCE (rtrn)
	If AllOf(Not Sensing LeftAhead Friend
		 Not Sensing Ahead Friend
		 Not Sensing RightAhead Friend) Then
		Call MAKETRAIL (0, rtrn)
	Else
		Drop .
		Drop .
		Drop .
		If AllOf(Not Sensing Ahead Friend
			 Not Sensing RightAhead Friend
			 Sensing LeftAhead Marker 0) Then
			Call MAKETRAIL (1, rtrn)
		Else
		End
	End
End
			

		
start:
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Drop forage

	;; 
	;; Go get some food -- from bouncer.asm
	;; Returns to rtrn when it has food
	;; 
Func FINDFOOD (rtrn)
try-to-find-food:
	Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
	PickUp got-food no-food-here
no-food-here:
	Move try-to-find-food man-i-hit-something
man-i-hit-something:
	;;  try turning in a random direction.
	Flip 2 rotate-cw rotate-ccw
rotate-cw:
	Turn Right Next
	;;  maybe keep turning!
	Flip 2 rotate-cw try-to-find-food
rotate-ccw:
	Turn Left Next
	Flip 2 rotate-ccw try-to-find-food
got-food:
	Turn Right .
	Turn Right .
	Turn Right rtrn
End


	;;
	;; If you have food walk around until you find a spoke -- then run-home
	;; 
Func FINDHOME (rtrn)
have-food:
	Sense drop-my-food no-base-here Here Home

drop-my-food:
	Drop .
	Turn Right .
	Turn Right .
	Turn Right rtrn		

no-base-here:
	If Sensing Ahead Marker 1 Then
		If Sensing Here Marker 0 Then
			If Sensing RightAhead Marker 1 Then
				Turn Right run-home
			Else
				Turn Right .
				Turn Right run-home
			End
		Else 
			If Sensing RightAhead Marker 1 Then
				Turn Left run-home
			Else
				; There must be a marker to AheadLeft
				Turn Left .
				Turn Left run-home
			End
		End
	Else 
		If Sensing Ahead Marker 0 Then
			If Sensing Here Marker 1 Then
				If Sensing RightAhead Marker 0 Then
					Turn Left run-home
				Else
					Turn Left .
					Turn Left run-home
				End
			Else 
				If Sensing LeftAhead Marker 0 Then
					Turn Right run-home
				Else
					; There must be a marker to AheadLeft
					Turn Right .
					Turn Right run-home
				End
			End
		Else
			Move have-food fhit-something
		End
	End

fhit-something:
	Flip 2 frotate-cw frotate-ccw

frotate-cw:
	Turn Right Next
	Flip 2 frotate-cw have-food

frotate-ccw:
	Turn Left Next
	Flip 2 frotate-ccw have-food

run-home:
	Move . fhit-something
	Sense drop-my-food run-home Here Home
End

	
forage:
	Call FINDFOOD (go-home)

go-home:
	Call FINDHOME (forage)


