; A crazy hybrid of kicker and stapler

If Flip 3 Then

edge1:
  SetName "!" "?"
  If Sensing RightAhead Home Then
    Move edge1 edge1turn
  Else
edge1turn:
    Turn Right edge1
  End
 

Else
    
attack-you:	
    Sense found-base-you no-enemy-base-you Here FoeHome

;;;  try to orient ourselves so that we are on the edge,
;;;  then walk around it until we are adjacent to a friend
found-base-you:
;;;  might as well pick up their food--it's a free point!
;;;  they probably leave it on the edge, anyway. once we get 
;;;  critical density, we could perhaps start removing it from
;;;  base...
    PickUp Next Next
try-to-face-cw-you:	
;;;  now try to face cw.
    If AllOf(Sensing Ahead FoeHome
	     Not (Sensing LeftAhead FoeHome)) Goto at-base-facing-cw-you
;;;  not yet, so turn and try again
    Turn Right try-to-face-cw-you

;;; walk around the base, to avoid being killed, and to make space
;;; for friends trying to get in
at-base-facing-cw-you:  
    Move found-base-you at-base-facing-cw-you
    
;;;  keep looking ... 
no-enemy-base-you:
    Move attack-you hit-while-attacking-you

hit-while-attacking-you:
;;;  see what I hit. if rock, turn:
    If Sensing Ahead Rock Goto turn-away-you
;;;  if a friend or foe on base,
;;;  just wait for it to move out of the way.
;;;  we have priority because of a tight loop.
;;;  on the other hand, we may want to sense around
;;;  for lots of foes and run if we're about to
;;;  be (accidentally) captured
    Sense blocked-at-base-you Next Ahead FoeHome
;;;  otherwise, just turn away:	
    
turn-away-you:
    Flip 2 arot-cw-you arot-ccw-you
arot-cw-you:
    Turn Right Next
    Flip 3 arot-cw-you no-enemy-base-you
arot-ccw-you:
    Turn Left Next
    Flip 3 arot-ccw-you no-enemy-base-you

;;; I know I'm facing their base, on non-base
blocked-at-base-you:
;;;  XX randomly decide to go forage. (interval 18 * 30)
    If Flip 540 Goto become-forager
    If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base-you
;;;  XX by invt can go directly to found-base
    Move attack-you blocked-at-base-you




	

become-forager:
;;; ChangeSymbol F U
try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
forage:	
ok-to-try-to-get-food:	
    PickUp got-food no-food-here
no-food-here:
    Move try-to-find-food man-i-hit-something

man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right Next
    ;;  maybe keep turning!
    Flip 2 rotate-cw try-to-find-food

rotate-ccw:
    Turn Left Next
    Flip 2 rotate-ccw try-to-find-food


got-food:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base
have-food:
    If AnyOf(Sensing Ahead Friend Sensing Here Home) Then Drop no-food-here Else Move have-food fhit-something End


got-food-no-friend-drop:
    Turn Left Next
    Turn Left Next
    Turn Left Next
    ;;  try to find base
have-food-no-friend-drop:
    If Sensing Here Home Then Drop no-food-here Else Move have-food-no-friend-drop fhit-something End
	


fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right Next
    Flip 2 frotate-cw have-food

frotate-ccw:
    Turn Left Next
    Flip 2 frotate-ccw have-food

fhit-something-no-friend-drop:
    Flip 2 frotate-cw-no-friend-drop frotate-ccw-no-friend-drop

frotate-cw-no-friend-drop:
    Turn Right Next
    Flip 2 frotate-cw-no-friend-drop have-food-no-friend-drop

frotate-ccw-no-friend-drop:
    Turn Left Next
    Flip 2 frotate-ccw-no-friend-drop have-food-no-friend-drop

End