
;;;  wall hugger tries to find and hug the wall to its right.
;;;  wherever it goes without food, it leaves a no-food-here marker (1)
;;;  wherever it goes with food, it leaves a i-have-food-marker (2)
;;;  the no-food marker is treated as a wall.
    
try-to-find-food:
    Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
    PickUp have-food no-food-here
no-food-here:
;;;  so try to turn right, if we can.
    Sense no-right-turn Next RightAhead Marker 1
    Sense no-right-turn Next RightAhead Friend
    Sense no-right-turn Next RightAhead Foe
    Sense no-right-turn Next RightAhead Rock
    Turn Right Next
    
no-right-turn:	    
;;;  if we're going to wall from clear onto marker 1, turn left
    Sense just-walk Next Here Marker 1
    Sense Next just-walk Ahead Marker 1
    Mark 1 Next
    Turn Left no-food-here
    
just-walk:  
    Mark 1 Next
    Move try-to-find-food man-i-hit-something

man-i-hit-something:
    Mark 1 Next
    Turn Left no-food-here

;;  try to find base
have-food:
    Sense drop-my-food no-base-here Here Home

drop-my-food:
    Drop try-to-find-food
    
no-base-here:
    Mark 2 Next
    Move have-food fhit-something

fhit-something:
    Flip 2 frotate-cw frotate-ccw

frotate-cw:
    Turn Right Next
    Flip 2 frotate-cw have-food

frotate-ccw:
    Turn Left Next
    Flip 2 frotate-ccw have-food
