

structure AntGenes = 
  struct

    type marker = int
    type state = int

    val BRAINSIZE = 10000

    datatype sensedir = Here | Ahead | LeftAhead | RightAhead
    datatype lor = Left | Right
    datatype cond = Friend | Foe | FriendWithFood | FoeWithFood | Food | Rock | Marker of marker | FoeMarker | Home | FoeHome

    datatype instruction = 
      Sense of sensedir * state * state * cond
    | Mark of marker * state
    | Unmark of marker * state
    | PickUp of state * state
    | Drop of state
    | Turn of lor * state
    | Move of state * state
    | Flip of int * state * state

    type antbrain = instruction Vector.vector

  end
