
(* FIXME -- get real random numbers here ! 
   This is absolute rubbish for testing only!!! *)

structure CryptRand =
struct

    infix 6 ++ --
    infix 7 divv modd **
    infix 4 << >> <<= >>=
	
    structure N = IntInf

    val op ++ = N.+
    val op ** = N.*
    val op divv = N.div
    val op modd = N.mod

    val iton = N.fromInt

    val n0 = iton 0
    val n1 = iton 1
    val n2 = iton 2

    exception CryptRand of string

    val bad = ref (Word32.fromLargeInt (Time.toSeconds (Time.now())))

    (* XXX very bad *)
    fun random () =
	let in
	    bad := Word32.*(!bad, 0w177801);
	    bad := Word32.xorb(0wxF3014823, !bad);
	    bad := Word32.+(!bad, 0w9999111);
	    bad := Word32.>>(!bad, 0w1);
	    !bad
	end

    (* XXX bad *)
    fun bit () = (Word32.andb(random (), 0wx100) > 0w0)

    (* good. *)
    fun byte () = chr (Word32.toInt (Word32.andb(0w255, random ())))

    fun bytes 0 = nil
      | bytes n = byte () :: bytes (n - 1)

    fun vec n = String.implode (bytes n)

    (* good. *)
    fun nbits bits =
	let
	    fun gb acc 0 = acc
	      | gb acc n =
		gb (if bit () then acc ** n2 ++ n1 else acc ** n2) (n - 1)
	in
	    gb n0 bits
	end

    (* good. *)
    fun inrange (low, hi) =
	let
	    val range = IntInf.-(hi, low)
	    val _ = IntInf.> (range, n0) orelse raise CryptRand "bad range to inrange"
	    val rangel = 1 + Number.log2(range)

	    fun try () =
		let val b = IntInf.+(nbits rangel, low)
		in if IntInf.< (b, hi) then b else try ()
		end
	in
	    try ()
	end

end