
structure AsmIL = 
  struct
    type state = int option ref * AsmEL.label option

    datatype sensedir = datatype AsmEL.sensedir
    type marker = int (* ?? *)
    datatype lor = datatype AsmEL.lor
    datatype cond = Friend | Foe | FriendWithFood | FoeWithFood | Food | Rock | Marker of marker | FoeMarker | Home | FoeHome

    datatype 'st instruction = 
      Sense of sensedir * 'st * 'st * cond
    | Mark of marker * 'st
    | Unmark of marker * 'st
    | PickUp of 'st * 'st 
    | Drop of 'st
    | Turn of lor * 'st
    | Move of 'st * 'st
    | Flip of int * 'st * 'st
    (* Nonstandard things *)
    | Abort of string
    | Print of string
    | SetName of char * char

    type 'st antbrain = 'st instruction Vector.vector
  end
