at-home:
 	Flip 2 turn-and-move Next ; 50/50 chance of turning before moving
 	Move start start	; make a move

start:
	Flip 6 simple-out bouncer-out

	
try-to-find-food:
bouncer-out:	
	Sense no-food-here ok-to-try-to-get-food Here Home

no-food-here:
	Move try-to-find-food man-i-hit-something

ok-to-try-to-get-food:	
    PickUp got-food no-food-here


	
man-i-hit-something:
    ;;  try turning in a random direction.
    Flip 2 rotate-cw rotate-ccw

rotate-cw:
    Turn Right Next
    ;;  maybe keep turning!
    Flip 2 rotate-cw try-to-find-food

rotate-ccw:
    Turn Left Next
    Flip 2 rotate-ccw try-to-find-food



	
food-here:
	PickUp Next start
	Sense food-here-marker Next Here Marker 2
	Mark 0 Next
	Mark 1 Next

got-food:	
food-here-marker:		
	Turn Right Next
	Turn Right Next
	Turn Right follow-path-home

food-ahead:
	Sense food-ahead-marker Next Here Marker 0
	Sense food-ahead-marker Next Here Marker 1
	Mark 0 Next
	Mark 1 Next
food-ahead-marker:
	Move start blocked

food-left:
	Sense food-left-marker Next Here Marker 0
	Sense food-left-marker Next Here Marker 1	
	Mark 0 Next
food-left-marker:
	Turn Left simple-out

food-right:
	Sense food-right-marker Next Here Marker 0
	Sense food-right-marker Next Here Marker 1
	Mark 1 Next
food-right-marker:
	Turn Right simple-out

turn-and-move:
	Flip 2 Next turn-right-and-move
	Sense turn-left-marker Next Here Marker 0
	Sense turn-left-marker Next Here Marker 1
	Mark 0 Next
turn-left-marker:
	Turn Left Next
	Move simple-out blocked

turn-right-and-move:
	Sense turn-right-marker Next Here Marker 0
	Sense turn-right-marker Next Here Marker 1
	Mark 1 Next
turn-right-marker:
	Turn Right Next
	Move simple-out blocked

blocked:
	Turn Right Next
	Unmark 0 Next
	Unmark 1 simple-out

	
	
	
	
	
;;; FOOD GET
	
	
		
	;; We have food and we are going home. Assumes we are on the path.
follow-path-home:
	Sense drop-food Next Here Home
	Sense follow-straight Next Ahead Home
	Sense go-home-left Next LeftAhead Home
	Sense go-home-right Next RightAhead Home
	Sense Next follow-path-home-else Here Marker 0 ; Left or Straight
	Sense follow-straight follow-left Here Marker 1	; Straight
follow-path-home-else:	
	Sense follow-right random-walk-with-food Here Marker 1 ; Right


drop-food:
	Drop Next
	Turn Right Next
	Turn Right Next
	Move simple-out simple-out

follow-straight:
	Move follow-path-home blocked-with-food ; if we're blocked, just drop

blocked-with-food:
	Sense drop-food random-walk-with-food Ahead Friend
		
follow-left:
	Sense Next follow-left-else RightAhead Marker 0
	Turn Right follow-straight
follow-left-else:
	Sense Next reverse RightAhead Marker 1
	Turn Right follow-straight
			
follow-right:
	Sense Next follow-right-else LeftAhead Marker 0
	Turn Left follow-straight
follow-right-else:
	Sense Next reverse LeftAhead Marker 1
	Turn Left follow-straight

reverse:	
	Turn Right Next
	Turn Right Next
	Turn Right follow-straight

go-home-left:
	Turn Left follow-straight
go-home-right:
	Turn Right follow-straight

	;; We have food
random-walk-with-food:
	Flip 100 turn-random-with-food move-random-with-food 

move-random-with-food:
	Move follow-path-home turn-random-with-food

turn-random-with-food:
	Flip 2 turn-left-random-with-food turn-right-random-with-food

turn-left-random-with-food:
	Turn Left move-random-with-food

turn-right-random-with-food:
	Turn Right move-random-with-food
	



simple-out:
	Sense at-home Next Here Home
	Sense food-here Next Here Food
	Sense food-ahead Next Ahead Food
	Sense food-left Next LeftAhead Food 
	Sense food-right Next RightAhead Food 
; 	Flip 40 turn-and-move Next
	Sense start-marker Next Here Marker 0
	Sense start-marker Next Here Marker 1
	Mark 0 Next
	Mark 1 Next
start-marker:		
	Move simple-out blocked
