
;;;  like flicknitz but tries to get out of being stuck
    
;;; dedicate a few ants to filling in the borders of the map.
;;; this shrinks the search space, at the expense of a sense
;;; test.

;;;  this is a little bad because it changes orientation
;;;  if we're about to hit something
Func GET-UNSTUCK ()
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto unstuck
;;; stuck!

  gstuck-mode:
    If (Sensing Ahead Rock) Then
	If Flip 20 Then
	    Turn Left .
	Else
	    Turn Right .
	End
	If True Goto gstuck-mode
    Else
	Move . .
	If (Sensing Here Marker 5) Goto gstuck-mode
        If True Goto unstuck
    End
    
  unstuck:
End
    
Func BOUNCER ()
  ; A crazy hybrid of kicker and stapler

 If Flip 3 Then

  ;;;  in base:	 no need to avoid marker 5
  edge1:
    SetName "!" "?"
    If Sensing RightAhead Home Then
      Move edge1 edge1turn
    Else
  edge1turn:
      Turn Right edge1
    End


 Else

  attack-you:	
      Sense found-base-you no-enemy-base-you Here FoeHome

  ;;;  try to orient ourselves so that we are on the edge,
  ;;;  then walk around it until we are adjacent to a friend
  found-base-you:
  ;;;  might as well pick up their food--it's a free point!
  ;;;  they probably leave it on the edge, anyway. once we get 
  ;;;  critical density, we could perhaps start removing it from
  ;;;  base...
      PickUp Next Next
  try-to-face-cw-you:	
  ;;;  now try to face cw.
      If AllOf(Sensing Ahead FoeHome
	       Not (Sensing LeftAhead FoeHome)) Goto at-base-facing-cw-you
  ;;;  not yet, so turn and try again
      Turn Right try-to-face-cw-you

  ;;; walk around the base, to avoid being killed, and to make space
  ;;; for friends trying to get in
  at-base-facing-cw-you:  
      Move found-base-you at-base-facing-cw-you

  ;;;  keep looking ... 
  no-enemy-base-you:
  ;;;  don't walk onto marker5
      If (Sensing Ahead Marker 5) Then
	If (Flip 40) Then
	    Call GET-UNSTUCK()
	Else End
    
    	If True Goto hit-while-attacking-you

      Else End
      Move attack-you hit-while-attacking-you

  hit-while-attacking-you:
  ;;;  see what I hit. if rock, turn:
      If Sensing Ahead Rock Goto turn-away-you
  ;;;  if a friend or foe on base,
  ;;;  just wait for it to move out of the way.
  ;;;  we have priority because of a tight loop.
  ;;;  on the other hand, we may want to sense around
  ;;;  for lots of foes and run if we're about to
  ;;;  be (accidentally) captured
      Sense blocked-at-base-you Next Ahead FoeHome
  ;;;  otherwise, just turn away:	

  turn-away-you:
      Flip 2 arot-cw-you arot-ccw-you
  arot-cw-you:
      Turn Right Next
      Flip 3 arot-cw-you no-enemy-base-you
  arot-ccw-you:
      Turn Left Next
      Flip 3 arot-ccw-you no-enemy-base-you

  ;;; I know I'm facing their base, on non-base
  blocked-at-base-you:
  ;;;  XX randomly decide to go forage. (interval 18 * 30)
      If Flip 540 Goto become-forager
      If AnyOf (Sensing Ahead Foe Sensing Ahead Friend) Goto blocked-at-base-you
  ;;;  XX by invt can go directly to found-base
      Move attack-you blocked-at-base-you






  become-forager:
  ;;; ChangeSymbol F U
  try-to-find-food:
      Sense no-food-here ok-to-try-to-get-food Here Home
  forage:	
  ok-to-try-to-get-food:	
      PickUp got-food no-food-here
  no-food-here:
      If (Sensing Ahead Marker 5) Then
	If (Flip 40) Then
	    Call GET-UNSTUCK()
	Else End

    	If True Goto man-i-hit-something

      Else End
      Move try-to-find-food man-i-hit-something

  man-i-hit-something:
      ;;  try turning in a random direction.
      Flip 2 rotate-cw rotate-ccw

  rotate-cw:
      Turn Right Next
      ;;  maybe keep turning!
      Flip 2 rotate-cw try-to-find-food

  rotate-ccw:
      Turn Left Next
      Flip 2 rotate-ccw try-to-find-food


  got-food:
      Turn Left Next
      Turn Left Next
      Turn Left Next
      ;;  try to find base
  have-food:
      If AnyOf(Sensing Ahead Friend Sensing Here Home) Then 
	Drop no-food-here 
      Else 
        If (Sensing Ahead Marker 5) Then
	    If (Flip 40) Then
	       Call GET-UNSTUCK()
	    Else End
	    If True Goto fhit-something
	Else End
    	Move have-food fhit-something 
      End


  got-food-no-friend-drop:
      Turn Left Next
      Turn Left Next
      Turn Left Next
      ;;  try to find base
  have-food-no-friend-drop:
      If Sensing Here Home 
      Then Drop no-food-here 
      Else 
        If (Sensing Ahead Marker 5) Then
	    If (Flip 40) Then
		  Call GET-UNSTUCK()
	    Else End
	    If True Goto fhit-something
	Else End
        Move have-food-no-friend-drop fhit-something 
      End



  fhit-something:
      Flip 2 frotate-cw frotate-ccw

  frotate-cw:
      Turn Right Next
      Flip 2 frotate-cw have-food

  frotate-ccw:
      Turn Left Next
      Flip 2 frotate-ccw have-food

  fhit-something-no-friend-drop:
      Flip 2 frotate-cw-no-friend-drop frotate-ccw-no-friend-drop

  frotate-cw-no-friend-drop:
      Turn Right Next
      Flip 2 frotate-cw-no-friend-drop have-food-no-friend-drop

  frotate-ccw-no-friend-drop:
      Turn Left Next
      Flip 2 frotate-ccw-no-friend-drop have-food-no-friend-drop

 End
End



        
Func TURNAROUND()
    Turn Left .
    Turn Left .
    Turn Left .
End

Func RANDOM-DIR()
    If Flip 6 Goto done
    Turn Left .
    If Flip 5 Goto done
    Turn Left .
    If Flip 4 Goto done
    Turn Left .
    If Flip 3 Goto done
    Turn Left .
    If Flip 2 Goto done
    Turn Left .
done:	
End
    
Func MAYBEMOVE(condy, d, od, l)
    If condy Then
	Turn d .
	Move maybemove_ok maybemove_notok
    Else
	If True Goto mmend
    End
maybemove_ok:
    Turn od .
    Turn od l
maybemove_notok:	
    Turn od l
mmend:	
End

Func GET-OUT()
get-out-of-here:    
    Call RANDOM-DIR()
    ;; find a non-rock location
    If Sensing Ahead Rock Then
	Turn Left get-out-of-here
    Else 
	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    	Move . .
    End
End

        
Func STUBBORNMOVE(cond, ll)
tryagain:
    SetName "S" "S"
    Move success .
    If cond Goto ll

    Call MAYBEMOVE(Flip 4, Left, Right, tryagain)
    Call MAYBEMOVE(Flip 4, Right, Left, tryagain)

success:
    SetName "X" "O"
End

spoons-has-a-bug:
    If True Goto begin_floodfill
        
decide-role:
;;;  TUNABLE
    Repeat 4
      If AllOf (Not (Sensing Ahead Home)
	        Not (Sensing LeftAhead Home)
	        Not (Sensing RightAhead Home)) Goto spoons-has-a-bug
      Turn Left .
    End
;;; otherwise, just a regular dude.

regular-dude:
    Call BOUNCER()
    If True Goto regular-dude

    
begin_floodfill:  
Variable orientation Of (cw ccw) In    
  ;;;  XXX this can 'pinch off' areas of
  ;;;  the map and make them inaccessible

  ;;;  the idea of floodfill is to hug,
  ;;   always going counter-clockwise,
  ;;;  permanent objects (mark 5 and rocks)
  ;;;  laying down mark 5 as we go. If we
  ;;;  ever run across something useful, we
  ;;;  stop marking and become a regular dude.

  ;;;  (one idea would be to reserve another mark
  ;;;  for 'good')
  floodfill:
      SetName "F" "W"
      Move try-to-find-obstacle try-to-find-obstacle

  try-to-find-obstacle:
      If AnyOf (Sensing Ahead Rock
		Sensing Ahead Marker 5) Then
	 If AnyOf (Sensing Here Food
		   Sensing Here Home
		   Sensing Here FoeHome) Then
	    Call GET-OUT ()
 	 Else End

    	 ;;;  found an obstacle, and we're on clear ground.
	 SetName "E" "E"
	 Mark 5 .
	 Switch orientation Of
	   Case cw
	      Turn Right face-appropriate-edge
	   Case ccw
	      Turn Left face-appropriate-edge
	 End
        
      Else
      ;;;  should do some sort of evasive move. we can be on the
      ;;;  edge where there is food (dropped), or walking against
      ;;   another stubborn ant, etc.
	  Call STUBBORNMOVE(Flip 10, couldnt-move)
	  If True Goto try-to-find-obstacle
      End
  couldnt-move:
      SetName "!" "!"
      Call GET-OUT ()
      If True Goto try-to-find-obstacle

  ;;;  turn so that we have obstacle rightahead and
  ;;;  clear ahead. we know that we just made a mark,
  ;;;  but would have been on clear ground, and that
  ;;;  there is an obstacle rightahead.
  face-appropriate-edge:
  ;;;  if we find something cool on the edge, then turn around.
      If AnyOf (Sensing Ahead Food
		Sensing Ahead Home
		Sensing Ahead FoeHome) Then
        
        ;;;  back up
	Unmark 5 .
    	Call TURNAROUND()
	Move . .
	Unmark 5 .
	Switch orientation Of
	  Case cw
	    Turn Right .
    	    Assign orientation ccw
	  Case ccw
	    Turn Left .
    	    Assign orientation cw
	End
	If True Goto try-to-find-obstacle

      Else End

      If Not (AnyOf (Sensing Ahead Rock
		     Sensing Ahead Marker 5)) Then
	  ;;;  this should also be a stubborn move
	  Move new-edge-cell face-appropriate-edge
      Else
	  Flip 40 check-stuck .
	  Switch orientation Of
	    Case cw
	      Turn Right face-appropriate-edge
    	    Case ccw
	      Turn Left face-appropriate-edge
	  End
      End

  check-stuck:
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
    Turn Left .
    If Not (AnyOf (Sensing Ahead Marker 5
		   Sensing Ahead Rock)) Goto not-stuck
;;; stuck!

  stuck-mode:
    If (Sensing Ahead Rock) Then
	If Flip 20 Then
	    Turn Left .
	Else
	    Turn Right .
	End
	If True Goto stuck-mode
    Else
	Move . .
	If (Sensing Here Marker 5) Goto stuck-mode
	If (Flip 2) Then
	  ;;  maybe switch orientation
	  Switch orientation Of
	    Case cw
	      Assign orientation ccw
	    Case ccw
	      Assign orientation cw
	  End
	Else End

        If True Goto face-appropriate-edge
    End
    
  not-stuck:
    If True Goto face-appropriate-edge
    
  ;;;  could optimize this, since we know that after two
  ;;;  right turns we'll be facing an obstacle.
  new-edge-cell:
      Switch orientation Of
        Case cw
	  Turn Left .
	  Turn Left try-to-find-obstacle
    	Case ccw
	  Turn Right .
	  Turn Right try-to-find-obstacle
      End
    
  ;;;  should probably become forager.
  found-cool:
      SetName "C" "K"
  looping:
      Drop looping
End

