	;; 
	;; Make a straight path, then return to rtrn
	;; 

Func EAGERMOVE (cond, rtrn)
Move done do
do: If cond Goto rtrn  
Move done do
done:
End

Func MAKETRAIL (cond, mrk1, mrk2, rtrn)
        Turn Right .
repeat:
	Call EAGERMOVE (cond, rtrn)
	Mark mrk1 .
        Turn Left .
        Turn Left .
	Call EAGERMOVE (cond, rtrn)
	Mark mrk2 .
        Turn Right .
        Turn Right repeat

End


Func TESTONCE (rtrn)
	If AllOf(Not Sensing LeftAhead Friend
		 Not Sensing Ahead Friend
		 Not Sensing RightAhead Friend) Then
		 Call MAKETRAIL (Sensing Ahead Rock, 1, 0, rtrn)
	Else
	End
End
			
		
start:
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .
	Call TESTONCE (forage)
	Turn Right .

If Flip 2 Then
edge1:
;        SetName "!" "?"
        If Sensing RightAhead Home Then
          Move edge1 edge1turn
        Else
edge1turn:
          Turn Right edge1
        End
 
Else
	Drop forage
End
	;; 
	;; Go get some food -- from bouncer.asm
	;; Returns to rtrn when it has food
	;; 
Func FINDFOOD (rtrn)
try-to-find-food:
	Sense no-food-here ok-to-try-to-get-food Here Home
ok-to-try-to-get-food:	
	PickUp got-food .
   If Sensing RightAhead Food Then
     Turn Right no-food-here
   Else End
   If Sensing LeftAhead Food Then
     Turn Left no-food-here
   Else End
   If Sensing Ahead Marker 2 Then
     Turn Left ok-to-try-to-get-food
   Else End
   If Sensing Ahead Marker 3 Then
     Turn Right ok-to-try-to-get-food
   Else End
   If Sensing Here Marker 5 Then
     If AnyOf(Flip 4 Sensing Ahead Marker 5) Then
     Else 
      Flip 2 less .
      Turn Right .
less:
      Turn Right ok-to-try-to-get-food
     End
   Else End
no-food-here:
	Move try-to-find-food man-i-hit-something
man-i-hit-something:
	;;  try turning in a random direction.
	If Flip 2 Then Turn Right . Else Turn Left . End
        If True Goto try-to-find-food
got-food:
        Mark 5 .
	Turn Right .
	Turn Right .
	Turn Right rtrn
End


	;;
	;; If you have food walk around until you find a spoke -- then run-home
	;; 
Func FINDHOME (rtrn)

	Turn Right .
	Turn Right .
 If Not Sensing RightAhead Food Goto dont-swell
	Turn Left .
	Turn Left .
find-clear:
 If Sensing Ahead Marker 5 Goto  dont-swell
 If Sensing Here Food Then
  Move find-clear find-clear
 Else End

;;;;;;;;;; STEP ONE ;;;;;;;;;
; Make sure right shoulder is blocked


swell:
paint1: SetName "!" "!"
        If  AnyOf (
                   Sensing RightAhead Marker 5
                   Sensing RightAhead Food) Then
        Else
         Turn Right paint1
        End

;;;;;;;;;; STEP TWO ;;;;;;;;;
; Paint, if legal
paint2: SetName "?" "?"
        Mark 5 .
;;;;;;;;;; STEP THREE ;;;;;;;;;
; Make sure forward is clear

paint3: SetName "@" "@"
         If  AnyOf (Sensing Ahead Marker 5
                    Sensing Ahead Food) Then
 
         Turn Left paint3
         Else
         End
         Call EAGERMOVE (AnyOf(Sensing Ahead Rock
                               Sensing Ahead Home
                                Flip 100), dont-swell)
         If True Goto paint1
      



dont-swell:
        SetName "X" "O"
	Turn Left .
	Turn Left .
If Flip 30 Then
    Call MAKETRAIL (AnyOf(Sensing Ahead Rock
                          Sensing Ahead Home
                          Sensing Ahead Marker 0
                          Sensing Ahead Marker 1
                          Sensing Ahead Marker 2
                          Sensing Ahead Marker 3), 2, 3, have-food)
    Else End

have-food:
        SetName "=" "="
	Sense drop-my-food no-base-here Here Home

drop-my-food:
	Drop .
	Turn Right .
	Turn Right .
	Turn Right rtrn		

no-base-here:
   
   If Sensing Ahead Marker 1 Then
     If AnyOf (Sensing Here Marker 0 Sensing Here Marker 1) Then
     Else
     Turn Left no-base-here
     End
   Else End
   If Sensing Ahead Marker 0 Then
     Turn Right no-base-here
   Else End
 
   Call EAGERMOVE (AnyOf(Sensing Ahead Rock Flip 100), fhit-something)
   SetName "/" "/"   
   Sense have-food have-food Ahead Rock


fhit-something:
	If Flip 2 Then 
         Turn Right have-food
        Else
         Turn Left have-food 
        End



End ; FINDHOME

	
forage:
        SetName "*" "*"
	Call FINDFOOD (go-home)

go-home:
        SetName "@" "@"
	Call FINDHOME (forage)


