val brain = Params.paramacc [] (SOME("-brains", "list of BRAINS", #",")) "brain"
val world = Params.paramacc [] (SOME("-worlds", "list of WORLDS", #",")) "world"

val _ =
  (case (Params.docommandline (), !brain, !world) of
    (nil, _::_, _::_) => 
      let in
        Arena.run (!world, !brain)
      end
    | _ => 
      let in
        print (Params.usage ());
        print ("simulator -worlds w1,w2,w3 -brains b1,b2,b3\n" ^
               "(you must provide at least one world and one brain\n")
      end)
     handle Ants.Ants s => print ("ants: " ^ s ^ "\n")
          | Parse.Parse s => print ("parse: " ^ s ^ "\n")
