structure Random : RANDOM =
struct
    open Word32

    val cell = ref (fromInt 0)

    fun chug () = cell := 
      (andb(>>(fromInt ~1, Word.fromInt 1),
            (!cell) * (fromInt 22695477) + (fromInt 1)))

    fun seed x = 
        let in 
            cell := fromInt x;
            chug();
            chug();
            chug()
        end
    
    fun randomint n = 
      (chug(); 
       let val shifted = !cell div (fromInt 65536)
       in
         Int.mod(toInt (shifted mod (fromInt 16384)), n)
       end)
(*
    fun randomint n = 
      (chug(); 
       Int.mod(toInt ((!cell div (fromInt 65536)) mod (fromInt 16384)), n))
*)

    (* testing 
    val _ = seed 12345 
    val _ =  Util.for 0 99 (fn _ => print ((Int.toString (randomint 2)) ^ "\n"));
    *)
end