signature SIMULATOR =
sig

    val mapfold : (Ants.pos * Ants.cell * 'a -> 'a) -> 'a -> Ants.map -> 'a
    val populate : Ants.map -> Ants.ant option Array.array
    val score : Ants.map -> int * int

    (* simulate (red brain, black brain, world, seed, max round, debug) *)
    val simulate : string * string * string * int * int * bool -> unit
    val run : string * string * string * int * int * bool -> int * int

end